#ifndef __DATA_H__
#define  __DATA_H__

#include "libsprite/Wlib.h"
#include "struct.h"

extern W_Window gal, baseWin;

extern char *imagedir;
extern int verbose_image_loading;
extern int forceMono;
extern int xpm, useOR;

extern W_Color backColor;

extern int buttonDown;
extern char *imagedirend;

extern W_Image *playerShip, *playerTorp, *enemyTorp, *shieldImage, *bubbleImage;

extern int paused;

extern int gameOver;
extern int getting_name;

extern int counter;

extern int alien_shape[];

#ifdef SOUND
extern char *unixSoundPath;
#ifndef NAS_SOUND
extern char *unixSoundDev;
#endif
extern int playSounds;
#endif

extern int title_page, pagetimer;

extern struct alien aliens[];

extern int level;

extern char output_string[];

extern W_Image *expImage, *bubbleImages[];


#endif //  __DATA_H__
