#ifndef __DEFS_H__
#define __DEFS_H__
//#define ACCELERATION
//#define CHEAT_LIKE_NOTHING_ELSE
/* WARNING!  Defining this will cause the weapons to become insanely powerful
   insanely fast, thus causing the game to jerk off more than a teenage boy
   whenever you fire. */
/* I have no sympathy for cheaters, so if the problem does not show up in normal
   play, I won't fix it.:P */
#ifdef CHEAT_LIKE_NOTHING_ELSE
/* Some of these however, may be defined by themselves without causing too much
   jerking. */
#define TESTING_PRIZE_CODE
#define WMD
#define NO_USELESS_PRIZES
#define NO_DEATH_PENALTY
#define INCREMENTAL_WEAPON_INCREASE
#define SEEKING_LEMONS
#endif // CHEAT_LIKE_NOTHING_ELSE
#define MORE_ALIENS
#define MORE_FLAGSHIPS
#define MORE_ATTACKING
#define MORE_SHOOTING
#if defined(MORE_ALIENS)
#define VERSION "1.6d"
#else /* defined(MORE_ALIENS)*/
#define VERSION "1.6c"
#endif /* defined(MORE_ALIENS)*/

#if defined(MORE_ATTACKING)
#define MAX_ATTACKING 1 + (level*4)
#else /* MORE_ATTACKING */
#define MAX_ATTACKING 1 + (level*2)
#endif /* MORE_ATTACKING */

#if defined(MORE_SHOOTING)
#define MAX_ETORPS 10 + (level*10)
#else /* MORE_SHOOTING */
#define MAX_ETORPS 10 + (level*5)
#endif /* MORE_SHOOTING */

#if !defined(MORE_ALIENS)
#define MAX_TIMES_TORPS_CAN_WRAP 4
#define MAXALIENS 60
#else /* !defined(MORE_ALIENS)*/
#define MAX_TIMES_TORPS_CAN_WRAP 16
#define MAXALIENS 240
#define ENTRY_DEFINED_ALIENS 60
#endif /* !defined(MORE_ALIENS)*/
#define TORPSPEED 1
/*#define CLUSTERSPEED 10*/

#ifdef WMD
#define MAXTORPS 10000
#define WEAPON_FACTOR 10
#define BLOOD_SIZE 20
#define BLOOD_FACTOR 20
#else // WMD
#define MAXTORPS 1000
#define WEAPON_FACTOR 1
#define BLOOD_SIZE 3
#define BLOOD_FACTOR 5
#endif // WMD

#define ETORPSPEED 5
#define ETORP_MISS 200

#if defined (ACCELERATION)
#define MINSPEED 1
#define MAXSPEED 15
#else /* ACCELERATION */
#define MINSPEED 4
#define MAXSPEED 18
#endif /* ACCELERATION */

#define STATUS_BAR_HEIGHT 40
#define WINWIDTH 400
#define WINHEIGHT (500 + STATUS_BAR_HEIGHT)

#define WRAP_DELTA 20
#define SPACE_HEIGHT 500
#define SPACE_WIDTH 400
#define SPACE_X_MAX (SPACE_WIDTH+WRAP_DELTA)
#define SPACE_X_MIN (-WRAP_DELTA)
#define SPACE_X_SIZE (SPACE_X_MAX+WRAP_DELTA)
#define SPACE_Y_MAX (SPACE_HEIGHT+WRAP_DELTA)
#define SPACE_Y_MIN (-WRAP_DELTA)
#define SPACE_Y_SIZE (SPACE_Y_MAX+WRAP_DELTA)

#define NUMSTARS 30

#define TURNSPEED 10

#define UTIMER 33333

#define START_NEXT_BONUS 20000
#define BONUSSHIPSCORE 50000
#define START_SHIPS 2

#define ABS(a)			/* abs(a) */ (((a) < 0) ? -(a) : (a))

#define LEFTKEY         0x01
#define RIGHTKEY        0x02
#define UPKEY           0x04
#define DOWNKEY         0x08
#define FIREKEY         0x10
#define CHANGE_FIRE_KEYA 0x20
#define CHANGE_FIRE_KEYB 0x40

#ifdef USE_LRAND48
#define random() lrand48()
#endif

#if defined(MORE_ALIENS)
#if defined(TESTING_PRIZE_CODE)
#define PRIZECHANCE (8.0)
#else /* TESTING_PRIZE_CODE */
#define PRIZECHANCE (80.0)
#endif /* TESTING_PRIZE_CODE */
#else /* defined(MORE_ALIENS)*/
#if defined(TESTING_PRIZE_CODE)
#define PRIZECHANCE (3.0)
#else /* TESTING_PRIZE_CODE */
#define PRIZECHANCE (30.0)
#endif /* TESTING_PRIZE_CODE */
#endif /* defined(MORE_ALIENS)*/

#define TORPCHANCE 60
#define WORST_TORPCHANCE 35

#define SHIELDTIME 300
#define FLASH_TIME 50
#define MAX_DEAD_TIME 500
#define MIN_DEAD_TIME 25

#define ALIENSHAPES 17

#define ENTRY_DEFINED_ALIENS 60 
#define FLAGSHIPS_AND_GUARDS 20
#define MORE_ALIENS_PER_INC  10
#define LEVELS_PER_INC        5
#define FLAGSHIPS            10

#define FLAG_SHIP_0   30
#define FLAG_SHIP_11  31
#define GUARD_SHIP_1  20
#define GUARD_SHIP_12 21

#define DEBUG_DIR
/*
#define DEBUG_NEW_ALIEN
#define DEBUG_DO_ALIENS
#define DEBUG_DO_ENTER
#define DEBUG_ALIEN_ESCORTING
*/
/*
#define DEBUG_DO_BUBBLES
#define DEBUG_SCORE_FLAGSHIP
*/

/*#define SHOW_KEY_DOWN*/

/*#define DEBUG_COLLISION_CHECK_PLAYER*/

#define OUT_FILE stderr

#define LEFT_ARROW  'b'+128
#define RIGHT_ARROW 'f'+128

#define DEBUG_PRINT(message) do                                                     \
  {                                                                                 \
    fprintf(OUT_FILE, "%s: %s: %d: %s\n", __FILE__, __PRETTY_FUNCTION__, __LINE__, message); \
  }                                                                                 \
while(0)

#define ASSERT(expression, message) do          \
  {                                             \
    if(!(expression))                           \
    {                                           \
      DEBUG_PRINT(message);                     \
      abort();                                  \
    }                                           \
  }                                             \
while(0)

#endif // __DEFS_H__
