#ifndef __DRAW_H__
#define __DRAW_H__

void prep_draw_area(void);
void display_draw_area(void);
void draw_image_wrapper(W_Window window, int x, int y, int frame, W_Image *image
  , W_Color color);
void mask_text_wrapper(W_Window window, int x, int y, W_Color color, char *str
  , int len, W_Font font);
void cache_clear_area_wrapper(W_Window window, int x, int y, int width, int height);
void clear_area_wrapper(W_Window window, int x, int y, unsigned int width
  , unsigned int height);
void draw_pause(void);
void draw_explosions(void);
void draw_bubbles(void);
void draw_blood(void);
void draw_stars(void);
void draw_level_announcement(void);
void draw_torps(void);
void draw_aliens(void);
void draw_etorps(void);
void draw_player(void);
void draw_prizes(void);
void draw_score(void);
void draw_output_string(void);

#endif
