#include "libsprite/Wlib.h"
#include "struct.h"

void clear_events(void)
  {
    W_Event event;
    while(W_EventsPending())
    {
      W_NextEvent(&event);
    }
  }

ev_t wait_get_non_keyup_event(void)
  {
    W_Event event;
    ev_t final_event;
    while(!W_EventsPending())
    {} // Just wait for an event.
    W_NextEvent(&event);
    while(event.type == W_EV_KEY_OFF)
    {
      while(!W_EventsPending())
      {} // Just wait for an event.
      W_NextEvent(&event);
    }
    final_event.key = event.key;
    final_event.type = event.type;
    return final_event;
  }

int events_pending(void)
  {
    return W_EventsPending();
  }

ev_t next_event(void)
  {
    ev_t event;
    W_Event wev;
    W_NextEvent(&wev);
    event.type= wev.type;
    event.key= wev.key;
    return event;
  }
