#ifndef __POINT_H__
#define __POINT_H__

double sqr(double a);
double cube(double a);
int get_random(int max);
point_t point_add(point_t rhs, point_t lhs);
point_t point_subtract(point_t rhs, point_t lhs);
point_t scalar_multiply(point_t rhs, double lhs);
point_t scalar_divide(point_t rhs, double lhs);
point_t unit_vector(point_t foo);
int wrap_object(point_t* location);

#endif
