#include "struct.h"
#include "data.h"
#include "defs.h"
#include "point.h"

struct star stars[NUMSTARS];
int starspeed = 1;


void init_stars()
  {
    int i;

    for(i=0;i<NUMSTARS;i++) {
      stars[i].location.x = get_random(WINWIDTH);
      stars[i].location.y = get_random(WINHEIGHT);
      stars[i].speed = (get_random(3))+1;
      switch(get_random(5)) {
        case 0:
          stars[i].color = W_White;
          break;
        case 1:
          stars[i].color = W_Green;
          break;
        case 2:
          stars[i].color = W_Cyan;
          break;
        case 3:
          stars[i].color = W_Red;
          break;
        default:
          stars[i].color = W_Yellow;
          break;
      }
    }
  }

void do_stars()
  {
    int i;
    
    for(i=0;i<NUMSTARS;i++) {
      if(!paused)
      stars[i].location.y+=stars[i].speed*((starspeed < 20) ? ABS(starspeed) : 20);
      if(stars[i].location.y >= WINHEIGHT) {
        stars[i].location.y-=WINHEIGHT+starspeed;
        stars[i].location.x = get_random(WINWIDTH);
        switch(get_random(5)) {
          case 0:
            stars[i].color = W_White;
            break;
          case 1:
            stars[i].color = W_Green;
            break;
          case 2:
            stars[i].color = W_Cyan;
            break;
          case 3:
            stars[i].color = W_Red;
            break;
          default:
            stars[i].color = W_Yellow;
            break;
        }
      }
    }
  }
