#ifndef __TORPS_H__
#define __TORPS_H__

extern torp_p torp_stuff;
extern torp_t torps[];

void init_torps(void);
void kill_torp(int id);
void do_torps(void);
void fire_torps2(player_t* player_p);
void torp_line(point_t location, int life, double base_torp_speed
  , double seperation, int torps, int cluster_bombs , double angle, int branches);
void torp_wave(point_t location, int life, double amplitude, int torps);
void spread_torps(point_t location, int life, double base_torp_speed
  , double base_torp_accel, double start_angle, double inc_angle
  , int torps,  int cluster_bombs, int fluctuate);
void torp_tree(point_t location, int life, int torps, int branches, double angle);

#endif
