/* images.h.  Contains the #defines and extern's for all the image management
   data [BDyess] */
/* automatically created by scripts/mkimgsrc */
#ifndef __IMAGES_H__
#define __IMAGES_H__

#include "libsprite/Wlib.h"

W_Image * getImage P((int offset));
void loadImageByFilename P((char *filename));
void loadAllImages P((void));

#define I_DEFAULT              0
#define I_AL                   0
#define I_ALIEN1               1
#define I_ALIEN10              2
#define I_ALIEN11              3
#define I_ALIEN12              4
#define I_ALIEN13              5
#define I_ALIEN14              6
#define I_ALIEN15              7
#define I_ALIEN16              8
#define I_ALIEN17              9
#define I_ALIEN2               10
#define I_ALIEN3               11
#define I_ALIEN4               12
#define I_ALIEN5               13
#define I_ALIEN6               14
#define I_ALIEN7               15
#define I_ALIEN8               16
#define I_ALIEN9               17
#define I_ETORP                18
#define I_EXPLOSION            19
#define I_EXTRA                20
#define I_MINISHIP             21
#define I_MTORP                22
#define I_PAUSE                23
#define I_PLAYER1              24
#define I_PLAYER2              25
#define I_PLAYER3              26
#define I_PR_BLANK             27
#define I_PR_BLIZZARD1         28
#define I_PR_BLIZZARD2         29
#define I_PR_BONUS_ATTRACTOR   30
#define I_PR_BONUS_DESTRUCTOR  31
#define I_PR_BONUS_REPULSOR    32
#define I_PR_BRAIN             33
#define I_PR_CHANGER           34
#define I_PR_CLUSTER_DOUB      35
#define I_PR_CLUSTER_SING      36
#define I_PR_CLUSTER_TRIP      37
#define I_PR_DEC_CANNON_SPREAD 38
#define I_PR_DEC_PRIZE_SPEED   39
#define I_PR_DEC_TORP_SPEED    40
#define I_PR_DOUB              41
#define I_PR_EXTRABULLET       42
#define I_PR_INC_CANNON_SPREAD 43
#define I_PR_INC_PRIZE_SPEED   44
#define I_PR_INC_TORP_SPEED    45
#define I_PR_LEMON             46
#define I_PR_MALUS_ATTRACTOR   47
#define I_PR_MALUS_DESTRUCTOR  48
#define I_PR_MALUS_REPULSOR    49
#define I_PR_NEUTRAL_ATTRACTOR 50
#define I_PR_NEUTRAL_DESTRUCTOR 51
#define I_PR_NEUTRAL_REPULSOR  52
#define I_PR_SAFETY_BUBBLE     53
#define I_PR_SHIELD            54
#define I_PR_SHOOT_DOWN_ETORPS 55
#define I_PR_SING              56
#define I_PR_SPEED             57
#define I_PR_TRIP              58
#define I_PR_WAVE_DOUB         59
#define I_PR_WAVE_SING         60
#define I_PR_WAVE_TRIP         61
#define I_PR_WRAP              62
#define I_S1000                63
#define I_S2000                64
#define I_S4000                65
#define I_S500                 66
#define I_SAFETY_BUBBLE        67
#define I_SHIELD               68
#define I_TITLE                69
#define I_LAST                 69

#endif // __IMAGES_H__
