#include <stdio.h>
#include <string.h>

#include "libsprite/Wlib.h"
#include "images.h"
#include "data.h"
#include "defs.h"
#include "struct.h"
#include "score.h"
#include "player.h"
#include "torps.h"

char scorestr[100] = "Score: 0000000", scorestr2[100] = "Score: 0000000";
char scorestr3[100] = "Score: 0000000", scorestr4[100] = "Score: 0000000";
char shipstr[4] ="";
W_Image *miniship, *extraImage;
int drawExtra = 0;
point_t extra;

void do_score()
{
    sprintf(scorestr, "Score: %07d Level: %02d Speed: %02d Weapon: %2.0f"
      , player_0.score, level, player_0.movespeed, player_0.weapons[0]);
    sprintf(scorestr2, "Spread: %2.0f Bubbles: %02d Cluster Weapon: %2.0f"
      , player_0.cannon_spread, player_0.safety_bubbles, player_0.weapons[1]);
    sprintf(scorestr3, "Launch speed: %02d Cluster Bombs: %02d Torp Life: %02d"
      , player_0.torp_velocity, player_0.cluster_bombs, player_0.torp_life);
    sprintf(scorestr4, "Wave weapon: %2.0f Tree weapon: %2.0f Numtorps: %03d"
      , player_0.weapons[2], player_0.weapons[3], torp_stuff.numtorps);
    
    if(player_0.ships>6)
    {
	sprintf(shipstr, "%d", player_0.ships);
    }
    if(player_0.last_score != player_0.score)
    {
	if((player_0.score > 0) && (player_0.score >= player_0.next_bonus))
        {
	    player_0.ships++;
	    extra.x = 0 - extraImage->width/2;
	    extra.y = WINHEIGHT/2;
	    drawExtra = 1;
	    if(player_0.next_bonus < BONUSSHIPSCORE)
		player_0.next_bonus = BONUSSHIPSCORE;
	    else
		player_0.next_bonus += BONUSSHIPSCORE;
	}
	player_0.last_score=player_0.score;
    }
}

void init_score()
{
    miniship = getImage(I_MINISHIP);
    extraImage = getImage(I_EXTRA);
}

